(defun nickshouse	(WIDTH		 HEIGHT		 SELF
	 /		 SELF.ENAME	 SELF.DATA
	 SELF.ORIGIN	 SELF.ANGLE	 SELF.SCALE
	 SELF.XSCALE	 SELF.YSCALE	 SELF.ZSCALE
	 SELF.LAYER	 SELF.OCS	 SELF.COLOR
	 SELF.LINETYPE	 SELF.LINEWEIGHT SELF.PROPERTIES
	 SELF.NAME	 SELF.WIDTH	 SELF.HEIGHT
	 MASTER.DATA	 MASTER.ORIGIN	 MASTER.ANGLE
	 MASTER.SCALE	 MASTER.XSCALE	 MASTER.YSCALE
	 MASTER.ZSCALE	 MASTER.LAYER	 MASTER.OCS
	 MASTER.COLOR	 MASTER.LINETYPE MASTER.LINEWEIGHT
	 MASTER.PROPERTIES		 MASTER.NAME
	 MASTER.ENAME	 LOCALMASTERBACKUP
	 OBJDATA	 CC:NEWINSERTIONPOINT
	 CC:OBJECTNAME	 CC:OBJECTDATA	 OLDCMDECHO
	 LISPLST	 RESULT		 CC:IMPORT
	 IMPORTDATA	 LST		 LASTENT
	 NEWSSET	 P1		 P2
	 P3		 P4		 ROOFX
	 ROOFY		 ROOFPT		 SELF.LAMBDA
	)
  (SETQ	SELF.LAMBDA
	 '((WIDTH	    HEIGHT	    SELF
	    /		    SELF.ENAME	    SELF.DATA
	    SELF.ORIGIN	    SELF.ANGLE	    SELF.SCALE
	    SELF.XSCALE	    SELF.YSCALE	    SELF.ZSCALE
	    SELF.LAYER	    SELF.OCS	    SELF.COLOR
	    SELF.LINETYPE   SELF.LINEWEIGHT SELF.PROPERTIES
	    SELF.NAME	    SELF.WIDTH	    SELF.HEIGHT
	    MASTER.DATA	    MASTER.ORIGIN   MASTER.ANGLE
	    MASTER.SCALE    MASTER.XSCALE   MASTER.YSCALE
	    MASTER.ZSCALE   MASTER.LAYER    MASTER.OCS
	    MASTER.COLOR    MASTER.LINETYPE MASTER.LINEWEIGHT
	    MASTER.PROPERTIES		    MASTER.NAME
	    MASTER.ENAME    LOCALMASTERBACKUP
	    OBJDATA	    CC:NEWINSERTIONPOINT
	    CC:OBJECTNAME   CC:OBJECTDATA   OLDCMDECHO
	    LISPLST	    RESULT	    CC:IMPORT
	    IMPORTDATA	    LST		    LASTENT
	    NEWSSET	    P1		    P2
	    P3		    P4		    ROOFX
	    ROOFY	    ROOFPT
	   )
	   (SETQ CALSCRIPT:VERSION "2024 JULY 10 BETA")
	   (SETQ IMPORTDATA '((WIDTH 100) (HEIGHT 100)))
	   (CC-INITIALIZE-OBJECT)
	   (CC-LAMBDACORE
	    '((SETQ SELF.NAME "NICKSHOUSE")
	      (COMMAND "cc-overwrite" "layer,color")
	      (IF
	       (AND MASTER.ORIGIN MASTER.WIDTH MASTER.XSCALE)
	       (SETQ
		NPT
		(+
		 (LIST
		  MASTER.ORIGIN
		  (LIST (* MASTER.WIDTH MASTER.XSCALE) 0)
		 )
		)
	       )
	      )
	      (IF
	       MASTER.ANGLE
	       (SETQ SELF.ANGLE MASTER.ANGLE)
	      )
	      (IF
	       (AND MASTER.ORIGIN MASTER.ANGLE NPT)
	       (SETQ
		SELF.ORIGIN
		(CAL "rot(npt,master.origin,r2d(master.angle))")
	       )
	      )
	      (SETQ P1 ORIGIN)
	      (SETQ P2 (+ (LIST P1 (LIST WIDTH 0))))
	      (SETQ P3 (+ (LIST P1 (LIST WIDTH HEIGHT))))
	      (SETQ P4 (+ (LIST P1 (LIST 0 HEIGHT))))
	      (SETQ
	       ROOFX
	       (+ (LIST (RXOF (LIST P1)) (/ WIDTH 2)))
	      )
	      (SETQ
	       ROOFY
	       (+ (LIST (RYOF (LIST P1)) (* HEIGHT 2)))
	      )
	      (SETQ ROOFPT (LIST ROOFX ROOFY))
	      (COMMAND "._PLINE" P1 P2 P3 ROOFPT P4 P3 P1 P4 P2 "")
	     )
	   )
	   (IF
	    (SETQ NEWSSET (CC-NEWSET LASTENT))
	    (IF
	     (SETQ
	      SELF.ENAME
	      (CC-MAKEBLOCK NEWSSET ORIGIN "*" SELF.ENAME)
	     )
	     (PROGN (CC-FINALIZE-OBJECT) (LIST SELF.ENAME))
	    )
	   )
	  )
  )
  (SETQ CALSCRIPT:VERSION "2024 JULY 10 BETA")
  (SETQ IMPORTDATA '((WIDTH 100) (HEIGHT 100)))
  (CC-INITIALIZE-OBJECT)
  (CC-LAMBDACORE
    '((SETQ SELF.NAME "NICKSHOUSE")
      (COMMAND "cc-overwrite" "layer,color")
      (IF
       (AND MASTER.ORIGIN MASTER.WIDTH MASTER.XSCALE)
       (SETQ
	NPT
	(+
	 (LIST MASTER.ORIGIN (LIST (* MASTER.WIDTH MASTER.XSCALE) 0))
	)
       )
      )
      (IF
       MASTER.ANGLE
       (SETQ SELF.ANGLE MASTER.ANGLE)
      )
      (IF
       (AND MASTER.ORIGIN MASTER.ANGLE NPT)
       (SETQ
	SELF.ORIGIN
	(CAL "rot(npt,master.origin,r2d(master.angle))")
       )
      )
      (SETQ P1 ORIGIN)
      (SETQ P2 (+ (LIST P1 (LIST WIDTH 0))))
      (SETQ P3 (+ (LIST P1 (LIST WIDTH HEIGHT))))
      (SETQ P4 (+ (LIST P1 (LIST 0 HEIGHT))))
      (SETQ ROOFX (+ (LIST (RXOF (LIST P1)) (/ WIDTH 2))))
      (SETQ ROOFY (+ (LIST (RYOF (LIST P1)) (* HEIGHT 2))))
      (SETQ ROOFPT (LIST ROOFX ROOFY))
      (COMMAND "._PLINE" P1 P2 P3 ROOFPT P4 P3 P1 P4 P2 "")
     )
  )
  (IF (SETQ NEWSSET (CC-NEWSET LASTENT))
    (IF	(SETQ SELF.ENAME (CC-MAKEBLOCK NEWSSET ORIGIN "*" SELF.ENAME))
      (PROGN (CC-FINALIZE-OBJECT) (LIST SELF.ENAME))
    )
  )
)

(defun c:nickshouse (/ inspt insangle width height)
  (setvar "cmdecho" 0)
  (command "._undo" "_group")
  (if (and (or (setq inspt (getpoint "\nInsertion point <(0 0 0)>: "))
	       (setq inspt '(0 0 0))
	   )
	   (or (setq insangle
		      (getangle inspt "\nInsertion angle <0>: ")
	       )
	       (setq insangle 0)
	   )
	   (or (setq width (getreal "\n  width <100>: "))
	       (setq width 100)
	   )
	   (or (setq height (getreal "\n  height <100>: "))
	       (setq height 100)
	   )
      )
    (nickshouse width height (list inspt insangle))
  )
  (command "._undo" "_end")
  (prin1)
)